package com.gic.enterprise.service.outer.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.enterprise.dto.AppletQrcodeDTO;
import com.gic.enterprise.entity.TabAppletQrcode;
import com.gic.enterprise.error.ErrorCode;
import com.gic.enterprise.service.AppletQrcodeApiService;
import com.gic.enterprise.service.AppletQrcodeService;
import com.gic.thirdparty.pic.QQCloudPicUtils;
import com.gic.thirdparty.pic.UploadResult;
import com.gic.wechat.business.api.service.wxa.WeixinWxaFunService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

@Service("appletQrcodeApiService")
public class AppletQrcodeApiServiceImpl implements AppletQrcodeApiService {
    @Autowired
    private AppletQrcodeService appletQrcodeService;
    @Autowired
    private WeixinWxaFunService weixinWxaFunService;

    @Override
    public ServiceResponse<Map<String, Object>> takeAppletQrcode(Integer enterpriseId, String appid, String path, String params) {
        TabAppletQrcode tabAppletQrcode = new TabAppletQrcode();
        tabAppletQrcode.setAppid(appid);
        tabAppletQrcode.setEnterpriseId(enterpriseId);
        tabAppletQrcode.setPath(path);
        tabAppletQrcode.setParams(params);
        int i = this.appletQrcodeService.saveQrcode(tabAppletQrcode);
        ServiceResponse<Map<String, Object>> wxaQrcode = this.weixinWxaFunService.createWxaQrcode(appid, path, 1280);
        if(wxaQrcode.isSuccess()){
            Map<String, Object> result = wxaQrcode.getResult();
            byte[] contents = (byte[]) result.get("content");
            UploadResult uploadResult = QQCloudPicUtils.uploadLocalPicStream("pic01", "", contents);
            Map<String, Object> pic = new HashMap<>();
            pic.put("fileId", uploadResult.getFileId());
            pic.put("url", uploadResult.getUrl());
            pic.put("downloadUrl", uploadResult.getDownloadUrl());
            pic.put("path", path+"?pageId="+i);
            ServiceResponse.success(pic);
        }
        return ServiceResponse.failure(ErrorCode.SYSTEM_ERROR.getCode(), "生成小程序二维码异常");
    }

    @Override
    public ServiceResponse<AppletQrcodeDTO> getAppletQrcode(Integer id) {
        return null;
    }
}
